<template>
    <div class="d-flex justify-content-between mt-3">
        <div>
            Showing {{fromPage}} to {{toPage}} of {{total}} rows
        </div>
        <div>
            <nav aria-label="Page navigation example" v-if="totalPages > 1">
                <ul class="pagination">
                    <li class="page-item" v-if="!isInFirstPage">
                        <button type="button" class="page-link" @click="onClickFirstPage" :disabled="isInFirstPage" :class="{disabled:isInFirstPage}">
                            <span aria-hidden="true"><i class="fas fa-chevron-left"></i></span>
                            <span class="sr-only">First</span>
                        </button>
                    </li>

                    <li class="page-item" v-if="!isInFirstPage">
                        <button type="button" class="page-link" @click="onClickPreviousPage" :disabled="isInFirstPage" :class="{disabled:isInFirstPage}">
                            <span aria-hidden="true"><i class="fas fa-angle-double-left"></i></span>
                            <span class="sr-only">Previous</span>
                        </button>
                    </li>

                    <li class="page-item" v-for="page in pages" :class="{active:page.isDisabled}">
                        <button type="button" class="page-link" @click="onClickPage(page.name)" :disabled="page.isDisabled" :class="{disabled:page.isDisabled}">
                            {{ page.name }}
                        </button>
                    </li>

                    <li class="page-item" v-if="!isInLastPage">
                        <button class="page-link" @click="onClickNextPage" :disabled="isInLastPage" :class="{disabled:isInLastPage}">
                            <span aria-hidden="true"><i class="fas fa-angle-double-right"></i></span>
                            <span class="sr-only">Next</span>
                        </button>
                    </li>

                    <li class="page-item" v-if="!isInLastPage">
                        <button class="page-link" @click="onClickLastPage" :disabled="isInLastPage" :class="{disabled:isInLastPage}">
                            <span aria-hidden="true"><i class="fas fa-chevron-right"></i></span>
                            <span class="sr-only">Last</span>
                        </button>
                    </li>
                </ul>
            </nav>
        </div>
    </div>
</template>

<script>
    export default {
        name: "pagination",
        props: {
            maxVisibleButtons: {
                type: Number,
                required: false,
                default: 5
            },
            totalPages: {
                type: Number,
                required: true
            },
            total: {
                type: Number,
                required: true
            },
            perPage: {
                type: Number,
                required: true
            },
            currentPage: {
                type: Number,
                required: true
            }
        },
        computed: {
            startPage() {
                // When on the first page
                if (this.currentPage === 1) {
                    return 1;
                }
                // When on the last page
                if (this.currentPage === this.totalPages && this.totalPages >= this.maxVisibleButtons) {
                    return this.totalPages - this.maxVisibleButtons + 1;
                }
                // When near the last page
                if (this.currentPage + 2 === this.totalPages && this.totalPages >= this.maxVisibleButtons) {
                    return this.currentPage - 2;
                }
                if (this.currentPage + 1 === this.totalPages && this.totalPages >= this.maxVisibleButtons) {
                    return this.currentPage - 3;
                }
                // When in between
                return this.currentPage - 1;
            },
            endPage() {
                return Math.min(this.startPage + this.maxVisibleButtons - 1, this.totalPages);
            },
            fromPage() {
                return ((this.currentPage-1) * this.perPage) + 1;
            },
            toPage() {
                return (this.isInLastPage) ? this.total : this.currentPage * this.perPage ;
            },
            pages() {
                const range = [];

                for (let i = this.startPage;
                     i <= Math.min(this.startPage + this.maxVisibleButtons - 1, this.totalPages);
                     i+= 1 ) {
                    range.push({
                        name: i,
                        isDisabled: i === this.currentPage
                    });
                }

                return range;
            },
            isInFirstPage() {
                return this.currentPage === 1;
            },
            isInLastPage() {
                return this.currentPage === this.totalPages;
            },
        },
        methods: {
            onClickFirstPage() {
                this.$emit('pagechanged', 1);
            },
            onClickPreviousPage() {
                this.$emit('pagechanged', this.currentPage - 1);
            },
            onClickPage(page) {
                this.$emit('pagechanged', page);
            },
            onClickNextPage() {
                this.$emit('pagechanged', this.currentPage + 1);
            },
            onClickLastPage() {
                this.$emit('pagechanged', this.totalPages);
            },
            isPageActive(page) {
                return this.currentPage === page;
            }
        }
    }
</script>
